(defmacro getopt (argv-sym opts &rest body)
  (labels

   ((opt-def (o)
      (destructuring-bind (v c &key def) o
        (if def
          (list (first o) def)
          (first o))))

    (opt-cond (o ac contract)
      (destructuring-bind (v c &key def) o
        `((string= ,ac ,c)
          ,@(if def
            `(,@(if contract
                `((unless (= x (1- (length a)))
                    (error "-~a option must be last contracted argument" ,c))))
              (unless (setf arg (cdr arg))
                (error "-~a option requires argument" ,c))
              (setf ,v (car arg)))
            `((setf ,v t))))))

    (arg-a ()
     `(if (and arg
               (>= (length (car arg)) 1)
               (char= (aref (car arg) 0) #\-))
        (subseq (car arg) 1)))

    (process-args ()
     `(do* ((arg (cdr *posix-argv*) (cdr arg))
            (a ,(arg-a) ,(arg-a)))
        ((null a) arg)
        (if (= (length a) 1)
          (cond
            ,@(mapcar (lambda (o) (opt-cond o 'a nil)) opts)
            (t (error "unknown option -~a" a)))
          (loop for c across a
                for x from 0
                do  (cond
                      ,@(mapcar (lambda (o) (opt-cond o 'c t)) opts)
                      (t (error "unknown option -~a" c))))))))

   `(let* (,@(mapcar #'opt-def opts)
           (,(if argv-sym argv-sym (gensym)) ,(process-args)))
      ,@body)))

