#include "client.h"
#include <def.h>
#include <rpc/client.h>
#include <lisp/lisp.h>
#include <io/fs.h>
#include <log/log.h>

#include <stdlib.h>
#include <signal.h>

static void term(int sig){
  (void)sig;
  rpcc_stop(EXIT_SUCCESS);
}

static void sig_setup(void){
  signal(SIGINT,  term);
  signal(SIGTERM, term);
}

int client_run(int argc,char **argv){
  int           code;
  lisp_frame_t  frame; 

  (void)argc;
  (void)argv;

  lisp_init();
  lisp_store(&frame);

  log_close();
  log_add(stderr,LOG_ERR);

  if(!fs_chdir(data_path)){
    return EXIT_FAILURE;
  }

  sig_setup();
  code = rpcc_run();
  lisp_load(&frame);
  return code;
}

