#ifndef CONFIG_H
#define CONFIG_H

#ifndef PREFIX
  #define PREFIX "/usr/local"
#endif

//#define IRON_BIG_ENDIAN   //machine endianess
//#define LOG_IOSPAM        //log all file read/writes
//#define LOG_NETSPAM       //log all rejected packets
//#define MEMSET_RED        //always zeroize unencrypted data
#define GREASYPAK_TRUNC     //minimize size of udp packets (reveals info)

#define PEER_MAX          64    //max number of peers
#define RXBUF_POW         18    //reorder. cap. 8*2^x paks (1gbit/s ~= 100k/sec)
#define GREASYPAK_MTU     1500  //ipv4 mtu to use for calc. max greasypak size

#define ETC_PATH          PREFIX "/etc"
#define DATA_PATH         PREFIX "/etc/greasynet"
#define RNG_SLOW_PATH     "/dev/random"   //rng used for key generation
#define RNG_FAST_PATH     "/dev/urandom"  //rng used for packet nonces etc

#define LOG_FLAGS_STDERR  (LOG_OUT | LOG_ERR | LOG_TIMEDATE) //log stderr flags
#define LOG_FLAGS_FILE    (LOG_OUT | LOG_ERR | LOG_TIMEDATE) //log file flags

#define BLOCK_MAX         100               //max # of blocks before discard
#define BLOCK_WAIT        (   1*NSEC_MSEC ) //retry interval on block

#define POLL_TIMEOUT      ( 100           ) //fd poll() timeout (msec)
#define TICK_INTERVAL_MAX (   1*NSEC_SEC  ) //max int. betwen periodic ops

#define PROD_INTERVAL_MAX (  10*NSEC_SEC  ) //max periodic prod interval
#define ADDR_INTERVAL_MAX ( 180*NSEC_SEC  ) //max periodic addr cast interval
#define COLD_TIMEOUT      (  30           ) //peer considered cold after (sec)

#define REKEY_TIMEOUT     (  10*NSEC_SEC  ) //max wait for response
#define REKEY_RETRY       ( 300*NSEC_MSEC ) //interval between attempts

//TODO: put values
#define FLOOD_DELAY       ( 100*NSEC_MSEC ) //constant propagation delay
#define FLOOD_BUF_POW2    6                 //flood buffer size 2^x
#define FLOOD_DEDUP_SHIFT 4                 //dedup capacity (buf_pow2<<x)
#define FLOOD_TTL         16                //ttl for packets originated

#endif

