#ifndef CRYPT_INTERNAL_H
#define CRYPT_INTERNAL_H

#include <stdint.h>
#include <stddef.h>

#define BYTE_BITS             8
#define WORD_SIZE             8
#define SHA384_BLOCK_SIZE     SHA512_BLOCK_SIZE
#define SHA512_BLOCK_SIZE     (1024/8)
#define SHA512_STATE_N        (SHA512_SIZE/WORD_SIZE)
#define SHA384_OUT_N          (SHA384_SIZE/WORD_SIZE)
#define SHA512_OUT_N          SHA512_STATE_N

extern uint64_t const h384_init[SHA512_STATE_N];
extern uint64_t const h512_init[SHA512_STATE_N];

void sha512_block   (uint64_t *state,uint8_t const *block);
void sha512_compute (uint64_t      *state,
                     size_t         state_block_n,
                     uint8_t const *data,
                     size_t         size);
void sha512_output  (uint8_t *out,uint64_t const *state,size_t n);

#endif

