#include "internal.h"
#include "pak.h"
#include "state/state.h"
#include <util/time.h>

bool addr_recv(peer_t *p,uint8_t *l,size_t l_size){
  addr_t addr; 

  addr.ip     = get_u32le(l+ADDR_IP_OFF);
  addr.port   = get_u16le(l+ADDR_PORT_OFF);
  addr.stamp  = 0;

  peer_addr_auto(p,addr);
  prod_send_cold(p,PROD_REQANS);
  return 1;
}

bool addr_flood(peer_t *p){
  uint8_t l[ADDR_SIZE];

  set_u32le(l+ADDR_IP_OFF,    state.extaddr.ip);
  set_u16le(l+ADDR_PORT_OFF,  state.extaddr.port);

  return flood_brd(p,PAK_TYPE_ADDR,l,sizeof(l));
}

void addr_tick(uint64_t ntime){
  for(size_t x = 0;x < peer_n;x++){
    peer_t *p = peer+x;

    if(ntime < p->addr_ntime+ADDR_INTERVAL_MAX) continue;
    if(!peer_cold(p,time_sec()))                continue;

    p->addr_ntime = ntime;
    addr_flood(p);
  }
}

