#include "cmd.h"

val_t rpc_add(val_t arg,size_t n){
  char const *err;
  peer_t     *p;
  char        id[sizeof(p->id)];

  if(n != 1) return usage(rpc_add);

  if(!str_set(car(arg),id,sizeof(id),&err)){
    return arg_err("id",err);
  }

  if(!id_valid(id,&err)){
    return arg_err("id",err);
  }

  if(peer_lookup(id)){
    return rpc_err("peer %s already exists",id);
  }

  p = peer_alloc();
  if(!p){
    return rpc_err("too many peers, increase PEER_MAX");
  }

  peer_init(p);
  strzcpy(p->id,id,sizeof(p->id));

  if(!ip_next(&p->ip)){
    return rpc_err("no more free ips in subnet");
  }

  if(!peer_save(p)){
    return rpc_err("failed to save peer");
  }

  peer_add();
  log_out("peer %s added",id);
  return val_ok;
}

