#include "cmd.h"
#include <daemon/pak.h>

val_t rpc_addkey(val_t arg,size_t n){
  peer_t     *p;
  uint8_t     key[KEY_SIZE];
  char const *err;
  val_t       verr;

  if(n != 2) return usage(rpc_addkey);

  if(!get_peer(car(arg),&p,&verr)){
    return verr;
  }

  if(state.ip == 0 || p->ip == 0){
    return rpc_err("virtual ips must be configured before key can be added");
  }

  if(!key_set(_nth(1,arg),key,&err)){
    BUF_ZERO(key);
    return arg_err("key",err);
  }

  if(entropy_missing(key,sizeof(key))){
    return rpc_err("entropy obviously missing from key");
  }

  if(peer_lookup_key(key)){
    BUF_ZERO(key);
    return rpc_err("this key already exists");
  }

  if(!peer_key_add(p,key,state.ip)){
    BUF_ZERO(key);
    return rpc_err("max keys reached for this peer");
  }

  BUF_ZERO(key);

  //TODO: shud send prod with specific pk herE
  if(p->pkey_n == 1){
    prod_send_cold(p,PROD_REQANS);
  }

  if(!peer_save(p)){
    return rpc_err("failed to save peer");
  }

  return val_ok;
}

