#include "cmd.h"
#include <crypt/crypt.h>
#include <util/hex.h>

val_t rpc_delkey(val_t arg,size_t n){
  peer_t     *p;
  pkey_t     *pk;
  uint8_t     key[KEY_SIZE];
  val_t       vkey;
  char const *err;
  val_t       verr;
  uint32_t    crc;

  if(n != 2) return usage(rpc_delkey);

  if(!get_peer(car(arg),&p,&verr)){
    return verr;
  }

  vkey = _nth(1,arg);

  if(_stringp(vkey) && _length(vkey) == HEX_LEN(CRC32_SIZE)){
    if(!crc_set(vkey,&crc,&err)){
      VAR_ZERO(crc);
      return arg_err("key",err);
    }
    pk = peer_key_lookupc(p,crc);
    VAR_ZERO(crc);
  }else{
    if(!key_set(vkey,key,&err)){
      BUF_ZERO(key);
      return arg_err("key",err);
    }
    pk = peer_key_lookup(p,key);
    BUF_ZERO(key);
  }

  if(!pk){
    return rpc_err("key doens't exist for this peer");
  }

  peer_pkey_del(p,pk);

  if(!peer_save(p)){
    return rpc_err("failed to save peer");
  }

  return val_ok;
}

