#include "cmd.h"

static val_t rpc_flag(val_t       arg,
                      size_t      n,
                      rpc_f       func,
                      char const *fsym,
                      uint32_t    f){

  val_t       tar;
  peer_t     *p;
  char const *err;
  val_t       verr;

  if(n < 1 || n > 2) return usage(func);

  tar = _nth(0,arg);
  if(!get_peer(tar,&p,&verr)){
    return verr;
  }

  if(n == 1){
    return list(sym(fsym),tar,flag_get(f,p->flags));
  }else{
    if(!flag_set(_nth(1,arg),f,&p->flags,&err)){
      return arg_err("enable",err);
    }
    return save_peer(p);
  }
}

val_t rpc_mute(val_t arg,size_t n){
  return rpc_flag(arg,n,rpc_mute,"MUTE",PEER_MUTE);
}

val_t rpc_brd(val_t arg,size_t n){
  return rpc_flag(arg,n,rpc_brd,"BRD",PEER_BRD);
}

