#include "cmd.h"

static rpc_cmdinfo_t *lookup_cmd(val_t cmd){
  for(size_t x = 0;x < rpc_cmd_n;x++){
    rpc_cmdinfo_t *i = rpc_cmdinfo+x;
    if(_eql(cmd,sym(i->sym_name))) return i;
  }
  return 0;
}

val_t rpc_help(val_t arg,size_t n){
  val_t           cmd = car(arg);
  rpc_cmdinfo_t  *i;

  if(n == 0){ 
    val_t r = list(PP_ALIST);
    for(size_t x = 0;x < rpc_cmd_n;x++){
      rpc_cmdinfo_t *i = rpc_cmdinfo+x;
      push(cons(sym(i->sym_name),str(i->desc)),r);
    }
    return list(sym("HELP-ALL"),nreverse(r));
  }

  if(n != 1 || !_symbolp(cmd)){
    return usage(rpc_help);
  }

  i = lookup_cmd(cmd);  
  if(i){
    return list(sym("HELP-CMD"),
                list(PP_ALIST,
                     cons(sym("DESC"),  str(i->desc)),
                     cons(sym("USAGE"), str(i->usage))));
  }else{
    return rpc_err("unknown command %s",_symbol_name(cmd));
  }
}

