#include "cmd.h"
#include <net/util.h>
#include <daemon/pak.h>

val_t rpc_id(val_t arg,size_t n){
  val_t       tar;
  peer_t     *p;
  char const *err;
  val_t       verr;

  if(n < 1 || n > 2) return usage(rpc_id);

  tar = _nth(0,arg);
  if(!get_peer(tar,&p,&verr)){
    return verr;
  }

  if(n == 1){
    return list(sym("ID"),tar,str_get(p->id));
  }else{
    char id[ID_BUF];

    if(!str_set(_nth(1,arg),id,sizeof(id),&err)){
      return arg_err("id",err);
    }

    if(!id_valid(id,&err)){
      return arg_err("new_id",err);
    }

    if(!peer_rename(p,id,&err)){
      return rpc_err("%s",err);
    }

    log_out("peer %s -> %s",p->id,id);
    strzcpy(p->id,id,sizeof(p->id));
    return save_peer(p);
  }
}

