#ifndef RPCSERV_INTERNAL_H
#define RPCSERV_INTERNAL_H

#include <daemon/state/state.h>
#include <daemon/peer/peer.h>
#include <lisp/lisp.h>
#include <rpc/server.h>
#include <stdbool.h>

typedef struct rpc_cmdinfo{
  char              sym_name[16];
  rpc_f             func;
  char const       *desc;
  char const       *usage;
}rpc_cmdinfo_t;

val_t usage         (rpc_f func);
val_t arg_err       (char const *arg,char const *err);

val_t peer_noexist  (char const *id);
bool  get_peer      (val_t target,peer_t **peer,val_t *verr);
bool  get_target    (val_t target,peer_t **peer,val_t *verr);

val_t save_cfg      (bool restart_prog,bool rebind_udp);
val_t save_peer     (peer_t *p);

#endif

