#include "cmd.h"
#include <daemon/internal.h>

val_t rpc_ip(val_t arg,size_t n){
  val_t       tar;
  peer_t     *p;
  char const *err;
  val_t       verr;

  if(n < 1 || n > 2) return usage(rpc_ip);

  tar = _nth(0,arg);
  if(!get_target(tar,&p,&verr)){
    return verr;
  }

  if(n == 1){
    return list(sym("IP"),
                tar,
                ipv4_get(p ? p->ip : state.ip));
  }else{
    uint32_t  ip;
    char      ips_a[IPV4_BUF];
    char      ips_b[IPV4_BUF];

    if(!ipv4_set(_nth(1,arg),&ip,&err)){
      return arg_err("ip",err);
    }
  
    if(!ip_valid(ip,&err)){
      return arg_err("ip",err);
    }

    if(p){
      log_out("peer %s ip %s -> %s",
              p,IP_A(p->ip),IP_B(ip));
      p->ip = ip;
      return save_peer(p);
    }else{
      log_out("self ip %s -> %s",
              IP_A(state.ip),IP_B(ip));
      state.ip = ip;
      return save_cfg(1,0);
    }
  }
}

