#include "cmd.h"
#include <net/util.h>
#include <util/time.h>

static val_t peer_keys(peer_t *p,bool crc){
  //TODO: sort by stamP
  return keys_get(p->pkey,p->pkey_n,p->id,crc);
}

static val_t _rpc_keys(val_t arg,size_t n,bool crc){
  if(n == 0){
    //TODO: sort by ...... iP?
    val_t lst = list(PP_LIST);
    for(size_t x = 0;x < peer_n;x++){
      lst = nconc(lst,peer_keys(peer+x,crc));
    }
    return lst;
  }else{
    peer_t *p;
    val_t   verr;
    if(!get_peer(car(arg),&p,&verr)){
      return verr;
    }
    return cons(PP_LIST,peer_keys(p,crc));
  }
}

val_t rpc_keys(val_t arg,size_t n){
  if(n > 1) return usage(rpc_keys);
  return list(sym("KEYS"),
              int_get(time_sec()),
              _rpc_keys(arg,n,1));
}

val_t rpc_fkeys(val_t arg,size_t n){
  if(n > 1) return usage(rpc_fkeys);
  return list(sym("FKEYS"),
              int_get(time_sec()),
              _rpc_keys(arg,n,0));
}

