#include "cmd.h"
#include <net/util.h>
#include <daemon/pak.h>

val_t rpc_locaddr(val_t arg,size_t n){
  val_t       tar;
  peer_t     *p;
  char const *err;
  val_t       verr;

  if(n < 1 || n > 2) return usage(rpc_locaddr);

  tar = _nth(0,arg);
  if(!get_peer(tar,&p,&verr)){
    return verr;
  }

  if(n == 1){
    return list(sym("LOCADDR"),
                tar,
                addr_get(p->locaddr));
  }else{
    addr_t a;
    if(!addr_set(_nth(1,arg),&a,&err)){
      return arg_err("addr",err);
    }

    if(a.ip != 0 && !ipv4_local(a.ip)){
      return arg_err("addr","ip must be local");
    }

    peer_addr_set(p,a,1);
    prod_send_cold(p,PROD_REQANS);
    return save_peer(p);
  }
}

