#include "cmd.h"
#include <net/util.h>

val_t rpc_stat(val_t arg,size_t n){
  val_t lst;

  if(n > 1) return usage(rpc_stat);

  lst = list(PP_ALIST);

  if(n == 0){
    #undef S
    #define S(S,V) push(cons(sym(#S),int_get(state.V)),lst)
    S(GRXN,grx_n);
    S(GRXB,grx_b);
    S(GTXN,gtx_n);
    S(GTXB,gtx_b);
    S(NRXN,nrx_n);
    S(NRXB,nrx_b);
    S(NTXN,ntx_n);
    S(NTXB,ntx_b);
    S(RRXN,rrx_n);
    S(RRXB,rrx_b);
    S(RTXN,rtx_n);
    S(RTXB,rtx_b);
    S(DRXN,drx_n);
    S(DRXB,drx_b);
    S(DTXN,dtx_n);
    S(DTXB,dtx_b);

    return list(sym("STAT-TOTAL"),nreverse(lst));
  }else{
    peer_t *p;
    val_t   verr;

    if(!get_peer(car(arg),&p,&verr)){
      return verr;
    }

    push(cons(sym("ID"),str(p->id)),lst);

    #undef S
    #define S(S,V) push(cons(sym(#S),int_get(p->V)),lst)
    S(GRXN,grx_n);
    S(GRXB,grx_b);
    S(GTXN,gtx_n);
    S(GTXB,gtx_b);
    S(NRXN,nrx_n);
    S(NRXB,nrx_b);
    S(NTXN,ntx_n);
    S(NTXB,ntx_b);
    S(RRXN,rrx_n);
    S(RRXB,rrx_b);
    S(RTXN,rtx_n);
    S(RTXB,rtx_b);
    S(DRXN,drx_n);
    S(DRXB,drx_b);
    S(DTXN,dtx_n);
    S(DTXB,dtx_b);

    return list(sym("STAT-PEER"),nreverse(lst));
  }
}

