#include "type.h"
#include "internal.h"
#include <util/time.h>

bool addr_set(val_t v,addr_t *a,char const **err){
  val_t     v_ip;
  val_t     v_port;
  val_t     v_stamp;
  uint32_t  ip;
  int64_t   port;
  int64_t   stamp;

  if(!_listp(v)){
    if(err) *err = "must be list";
    return 0;
  }

  if(!cdrassoc(v,"IP",&v_ip)){
    if(err) *err = "ip missing";
    return 0;
  }

  if(!cdrassoc(v,"PORT",&v_port)){
    if(err) *err = "port missing";
    return 0;
  }

  if(!cdrassoc(v,"STAMP",&v_stamp)){
    if(err) *err = "stamp missing";
    return 0;
  }

  if(!ipv4_set(v_ip,    &ip,                        err)) return 0;
  if(!int_set (v_port,  &port,  PORT_MIN, PORT_MAX, err)) return 0;
  if(!int_set (v_stamp, &stamp, STAMP_MIN,STAMP_MAX,err)) return 0;

  a->ip     = ip;
  a->port   = port;
  a->stamp  = stamp;

  return 1;
}

val_t addr_get(addr_t a){
  return list(PP_ALIST,
              cons(sym("IP" ),   ipv4_get(a.ip)),
              cons(sym("PORT"),  itg(a.port)),
              cons(sym("STAMP"), itg(a.stamp)));
}

bool addr_aset(val_t        sx,
               char const  *opt,
               addr_t       def,
               addr_t      *out,
               char const **err){

  val_t v;

  if(!cdrassoc(sx,opt,&v)){
    *out = def;
    return 1;
  }

  if(!addr_set(v,out,err)){
    return 0;
  }

  return 1;
}

