#include "type.h"
#include "internal.h"

bool int_set(val_t v,int64_t *imt,int64_t min,int64_t max,char const **err){
  int64_t i;

  if(!_integerp(v)){
    if(err) *err = "must be integer";
    return 0;
  }

  i = itg_data(v);

  if(i < min){
    if(err) *err = "integer too small";
    return 0;
  }

  if(i > max){
    if(err) *err = "integer too large";
    return 0;
  }

  *imt = i;
  return 1;
}

val_t int_get(int64_t imt){
  return itg(imt);
}

bool int_aset(val_t        sx,
              char const  *opt,
              int64_t      def,
              int64_t      min,
              int64_t      max,
              int64_t     *out,
              char const **err){

  val_t v;

  if(!cdrassoc(sx,opt,&v)){
    *out = def;
    return 1;
  } 

  return int_set(v,out,min,max,err);
}

