#include "type.h"
#include "internal.h"
#include <net/util.h>

bool ipv4_set(val_t v,uint32_t *ip,char const **err){
  if(!_stringp(v)){
    if(err) *err = "must be string";
    return 0;
  }

  if(!ipv4_parse(str_data(v),ip)){
    if(err) *err = "must be in format a.b.c.d";
    return 0;
  }

  return 1;
}

val_t ipv4_get(uint32_t ip){
  char buf[IPV4_BUF];
  ipv4_fmt(buf,sizeof(buf),ip);
  return str(buf);
}

bool ipv4_aset(val_t        sx,
               char const  *opt,
               uint32_t     def,
               uint32_t    *out,
               char const **err){

  val_t v;

  if(!cdrassoc(sx,opt,&v)){
    *out = def;
    return 1;
  }

  return ipv4_set(v,out,err);
}

