#include "type.h"
#include "internal.h"
#include <net/util.h>

bool subnet_set(val_t v,subnet_t *p,char const **err){
  if(!_stringp(v)){
    if(err) *err = "must be string";
    return 0;
  }

  if(!subnet_parse(str_data(v),p)){
    if(err) *err = "must be in format a.b.c.d/m";
    return 0;
  }

  return 1;
}

val_t subnet_get(subnet_t p){
  char buf[SUBNET_BUF];
  subnet_fmt(buf,sizeof(buf),p);
  return str(buf);
}

bool subnet_aset(val_t        sx,
                 char const  *opt,
                 subnet_t     def,
                 subnet_t    *out,
                 char const **err){

  val_t v;

  if(!cdrassoc(sx,opt,&v)){
    *out = def;
    return 1;
  }

  return subnet_set(v,out,err);
}

