#include "type.h"
#include "internal.h"
#include <util/string.h>
#include <string.h>

bool str_set(val_t v,char *buf,size_t buf_size,char const **err){
  char const *s;
  size_t      len;

  if(!_stringp(v)){
    if(err) *err = "must be string";
    return 0;
  }

  s   = str_data(v);
  len = strlen(s);

  if(len >= buf_size){
    if(err) *err = "string too long";
    return 0;
  }

  strzcpy(buf,s,buf_size);
  return 1;
}

val_t str_get(char const *buf){
  return str(buf);
}

bool str_aset(val_t        sx,
              char const  *opt,
              char const  *def,
              char        *out,
              size_t       out_size,
              char const **err){

  val_t v;

  if(!cdrassoc(sx,opt,&v)){
    strzcpy(out,def,out_size);
    return 1;
  }

  return str_set(v,out,out_size,err);
}

