#ifndef TYPE_H
#define TYPE_H

#include <daemon/util.h>
#include <daemon/peer/key.h>
#include <lisp/lisp.h>
#include <net/def.h>
#include <stddef.h>
#include <stdint.h>
#include <stdbool.h>

bool  int_set     (val_t        v,
                   int64_t     *imt,
                   int64_t      min,
                   int64_t      max,
                   char const **err);
val_t int_get     (int64_t      imt);
bool  int_aset    (val_t        sx,
                   char const  *opt,
                   int64_t      def,
                   int64_t      min,
                   int64_t      max,
                   int64_t     *out,
                   char const **err);

bool  flag_set    (val_t        v,
                   uint32_t     f,
                   uint32_t    *flags,
                   char const **err);
val_t flag_get    (uint32_t f,uint32_t flags);
bool  flag_aset   (val_t        sx,
                   char const  *opt,
                   uint32_t     def,
                   uint32_t     f,
                   uint32_t    *out,
                   char const **err);

bool  str_set     (val_t        v,
                   char        *buf,
                   size_t       buf_size,
                   char const **err);
val_t str_get     (char const  *buf);
bool  str_aset    (val_t        sx,
                   char const  *opt,
                   char const  *def,
                   char        *out,
                   size_t       out_size,
                   char const **err);

bool  ipv4_set    (val_t v,uint32_t *ip,char const **err);
val_t ipv4_get    (uint32_t     ip);
bool  ipv4_aset   (val_t        sx,
                   char const  *opt,
                   uint32_t     def,
                   uint32_t    *out,
                   char const **err);

bool  addr_set    (val_t v,addr_t *a,char const **err);
val_t addr_get    (addr_t       a);
bool  addr_aset   (val_t        sx,
                   char const  *opt,
                   addr_t       def,
                   addr_t      *out,
                   char const **err);

bool  subnet_set  (val_t v,subnet_t *p,char const **err);
val_t subnet_get  (subnet_t     p);
bool  subnet_aset (val_t        sx,
                   char const  *opt,
                   subnet_t     def,
                   subnet_t    *out,
                   char const **err);

bool  key_set     (val_t v,uint8_t *key,char const **err);
bool  crc_set     (val_t v,uint32_t *crc,char const **err);

bool  kinfo_set   (val_t v,pkey_t *k,char const **err);
val_t kinfo_get   (pkey_t const *k,char const *id,bool crc);

bool  keys_set    (val_t        v,
                   pkey_t      *k,
                   size_t      *k_n,
                   size_t       k_size,
                   char const **err);
val_t keys_get    (pkey_t const *k,size_t k_n,char const *id,bool crc);
bool  keys_aset   (val_t        sx,
                   char const  *opt,
                   pkey_t      *out,
                   size_t      *out_n,
                   size_t       out_size,
                   char const **err);

#endif

