#ifndef IO_H
#define IO_H

#include <stddef.h>
#include <stdint.h>
#include <stdbool.h>
#include <errno.h>

enum{
  IO_OK,
  IO_FAIL,
  IO_BLOCK,
  IO_DOWN,
};

int         fd_read     (int            fd,
                         uint8_t       *buf,
                         size_t         buf_size,
                         size_t        *size_out);
int         fd_write    (int            fd,
                         uint8_t const *buf,
                         size_t         buf_size,
                         size_t        *size_out);

inline bool errno_block (void);
inline bool errno_down  (void);

inline bool errno_block(void){
  return errno == EAGAIN        ||
         errno == EWOULDBLOCK   ||
         errno == ENOBUFS;
}

inline bool errno_down(void){
  return errno == EHOSTDOWN     ||
         errno == ENETDOWN      ||
         errno == EHOSTUNREACH  ||
         errno == ENETUNREACH;
}

#endif

