#include "sx.h"
#include "fs.h"
#include "internal.h"
#include <log/log.h>
#include <errno.h>

bool sx_load(char const *path,val_t *val){
  FILE *f;

  if(!fs_exists(path)){
    *val = NIL;
    return 1;
  }

  f = fp_open(path,"rb");
  if(!f) return 0;

  lisp_try{
    if(!lisp_read(f,val)){
      *val = NIL;
    }
  }lisp_catch{
    log_lisperr();
    fp_close(f);
    return 0;
  }

  fp_close(f);
  disk_read(path);
  return 1;
}

bool sx_save(char const *path,val_t val){
  FILE *f;

  if(fs_exists(path) && !fs_zero(path)){
    return 0;
  }

  f = fp_open(path,"wb");
  if(!f) return 0;

  lisp_try{
    lisp_pprint(f,val);
  }lisp_catch{
    log_lisperr();
    fp_close(f);
    return 0;
  }

  if(!fp_write(f,"\n",1)){
    fp_close(f);
    return 0;
  }

  fclose(f);
  disk_written(path);
  return 1;
}

