#ifndef LOG_H
#define LOG_H

#include <stdio.h>
#include <stdint.h>
#include <stdbool.h>
#include <stdarg.h>
#include <unistd.h>
#include <sys/types.h>

#define LOG_OUT          0x00000001
#define LOG_ERR          0x00000002
#define LOG_TIME         0x00000004
#define LOG_TIMEDATE     0x00000008

void log_add       (FILE *fp,uint32_t flags);
bool log_add_file  (char const  *path,
                    uint32_t     flags,
                    mode_t       mode,
                    uid_t        uid,
                    gid_t        gid);
void log_close     (void);

void log_v         (uint32_t flags,char const *fmt,va_list args);

void log_out       (char const *fmt,...);
void log_err       (char const *fmt,...);

void log_errno     (char const *call);
void log_lisperr   (void);

#endif

