#include "util.h"
#include <util/util.h>
#include <util/serial.h>
#include <util/string.h>

#include <os.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <netinet/in.h>

size_t addr_in(void *sa,addr_in_t addr){
  struct sockaddr_in *_sa = (struct sockaddr_in *)sa;
#if defined(OS_FBSD) || defined(OS_APPLE)
  _sa->sin_len         = sizeof(*_sa);
#endif
  _sa->sin_family      = AF_INET;
  _sa->sin_port        = host16be(addr.port);
  _sa->sin_addr.s_addr = host32be(addr.ip ? addr.ip : INADDR_ANY);
  return sizeof(*_sa);
}

void addr_in_out(void *sa,addr_in_t *addr){
  struct sockaddr_in *_sa = (struct sockaddr_in *)sa;
  addr->ip    = host32be(_sa->sin_addr.s_addr);
  addr->port  = host16be(_sa->sin_port);
}

size_t addr_un(void *sa,char const *path){
  struct sockaddr_un *_sa = (struct sockaddr_un *)sa;
  size_t len;
  _sa->sun_family = AF_UNIX;
  strzcpy(_sa->sun_path,path,sizeof(_sa->sun_path));
  len = offsetof(struct sockaddr_un,sun_path)+strlen(_sa->sun_path);
#if defined(OS_FBSD) || defined(OS_APPLE)
  _sa->sun_len = len;
#endif
  return len;
}

void addr_un_out(void    *sa,
                 size_t   sa_size,
                 char    *path,
                 size_t   path_size){

  struct sockaddr_un *_sa   = (struct sockaddr_un *)sa;
  size_t              size  = path_size;
  size_t              cunt  = sa_size-offsetof(struct sockaddr_un,sun_path)+1;
  if(size > cunt) size = cunt;
  strzcpy(path,_sa->sun_path,size);
}

