#include "udp.h"
#include "internal.h"
#include <io/io.h>

#include <unistd.h>
#include <netinet/in.h>

int udp_bind(uint16_t port,
             uint32_t flags){

  int fd = sock_udp();
  if(fd == -1) goto fail;
  if(!sock_flags    (fd,flags               )) goto close;
  if(!sock_bind_in  (fd,ADDR_IN_CONST(0,port))) goto close;
  return fd;
close:
  close(fd);
fail:
  return -1;
}

int udp_recvfrom(int        fd,
                 addr_in_t *addr_out,
                 uint8_t   *data,
                 size_t     size,
                 size_t    *size_out){

  struct sockaddr_in  sa;
  socklen_t           sa_size;
  int                 r;

  sa_size = sizeof(sa);
  r       = sock_recvfrom(fd,data,size,&sa,&sa_size,size_out);

  if(r == IO_OK && addr_out){
    addr_in_out(&sa,addr_out);
  }

  return r; 
}

int udp_sendto(int            fd,
               addr_in_t      addr,
               uint8_t const *data,
               size_t         size,
               size_t        *size_out){

  struct sockaddr_in  sa;
  socklen_t           sa_size;
  sa_size = addr_in(&sa,addr);
  return sock_sendto(fd,data,size,&sa,sa_size,size_out);
}

