#include "unix.h"
#include "internal.h"
#include <io/io.h>

#include <unistd.h>
#include <sys/un.h>

int unix_bind(char const *path,uint32_t flags,size_t bufsize){
  int fd = sock_unix_dgram();
  if(fd == -1) goto fail;
  if(!sock_flags    (fd,flags   )) goto close;
  if(!sock_bufsize  (fd,bufsize )) goto close; 
  if(!sock_bind_un  (fd,path    )) goto close;
  return fd;
close:
  close(fd);
fail:
  return -1;
}

int unix_recvfrom(int       fd,
                  char     *path_out,
                  size_t    path_out_size,
                  uint8_t  *data,
                  size_t    size,
                  size_t   *size_out){

  struct sockaddr_un  sa;
  socklen_t           sa_size;
  int                 r;

  sa_size = sizeof(sa);
  r       = sock_recvfrom(fd,data,size,&sa,&sa_size,size_out);

  if(r == IO_OK && path_out){
    addr_un_out(&sa,sa_size,path_out,path_out_size);
  }

  return r; 
}

int unix_sendto(int            fd,
                char const    *path,
                uint8_t const *data,
                size_t         size,
                size_t        *size_out){

  struct sockaddr_un  sa;
  socklen_t           sa_size;
  sa_size = addr_un(&sa,path);
  return sock_sendto(fd,data,size,&sa,sa_size,size_out);
}

