#ifndef RPC_SERVER_H
#define RPC_SERVER_H

#include <stdbool.h>
#include <lisp/lisp.h>

typedef val_t     (*rpc_f)(val_t arg,size_t n);

typedef struct rpc_cmd{
  val_t             sym;
  rpc_f             func;
}rpc_cmd_t;

extern val_t        sym_err;
extern val_t        sym_ok;
extern val_t        val_ok;

extern int          rpc_fd;

bool                rpcs_init (char const *path,rpc_cmd_t *cmd,size_t cmd_n);
bool                rpcs_exit (void);
void                rpcs_recv (void);

val_t               rpc_err   (char const *fmt,...);

#endif

