#include "string.h"
#include "util.h"
#include <stdint.h>

extern char  *strpcpy (char       *restrict dst,
                       char const *restrict src,
                       char const *restrict dst_end);

char *strzcpy(char        *restrict dst,
              char const  *restrict src,
              size_t                dst_size){

  assert(dst_size != 0);

  while(--dst_size){
    char c = *src++;
    if(!c) break;
    *dst++ = c;
  }
  *dst = 0;
  return dst;
}

char *strzcpy_fail(char        *restrict dst,
                   char const  *restrict src,
                   size_t                dst_size){

  while(dst_size--){
    char c = *src++;
    *dst = c;
    if(!c) return dst;
    dst++;
  }
  return 0;
}

char *strzcat(char       *restrict dst,
              char const *restrict src,
              size_t               dst_size){

  assert(dst_size != 0);

  do{
    if(!*dst) break;
    dst++;
  }while(--dst_size);
  assert(dst_size != 0);
  while(--dst_size){
    char c = *src++; 
    if(!c) break;
    *dst++ = c;
  }
  *dst = 0;
  return dst;
}

char *strchr0(char const *s,char c){
  while(*s && *s != c) s++;
  return PTR_UNCONST(s);
}

char *strnotchr0(char const *s,char n){
  for(char c;c = *s;s++){
    if(c != n) break;
  }
  return PTR_UNCONST(s);
}

