#ifndef STRING_H
#define STRING_H

#include <stdbool.h>
#include <stddef.h>
#include <assert.h>

char         *strzcpy       (char       *restrict dst,
                             char const *restrict src,
                             size_t               dst_size);
char         *strzcpy_fail  (char       *restrict dst,
                             char const *restrict src,
                             size_t               dst_size);
inline char  *strpcpy       (char       *restrict dst,
                             char const *restrict src,
                             char const *restrict dst_end);
char         *strzcat       (char       *restrict dst,
                             char const *restrict src,
                             size_t               dst_size);

char         *strchr0       (char const *s,char c);
char         *strnotchr0    (char const *s,char n);

inline char *strpcpy(char       *restrict dst,
                     char const *restrict src,
                     char const *restrict dst_end){

  assert(dst < dst_end);
  size_t dst_size = dst_end-dst;
  return strzcpy(dst,src,dst_size);
}

#endif

