#define _POSIX_C_SOURCE 200809L

#include "time.h"

#include <time.h>
#include <stdio.h>
#include <assert.h>

static void gettime(clockid_t id,struct timespec *ts){
  int r = clock_gettime(id,ts);
  assert(r != -1); (void)r;
}

uint64_t mono_nsec(void){
  struct timespec ts;
  gettime(CLOCK_MONOTONIC,&ts);
  return  (uint64_t)ts.tv_sec*NSEC_SEC
         +(uint64_t)ts.tv_nsec;
}

uint64_t time_sec(void){
  struct timespec ts;
  gettime(CLOCK_REALTIME,&ts);
  return ts.tv_sec;
}

void sleep_nsec(size_t nsec){
  struct timespec t;
  t.tv_sec  = nsec/NSEC_SEC;
  t.tv_nsec = nsec%NSEC_SEC;
  nanosleep(&t,0);
}

